#!BPY

# --------------------------------------------------
# Peremennie dlya dobavlenia knopki v menu Blender-a
# ==================================================

""" 
Name: 'Nash format (.nft)...'
Blender: 245
Group: 'Export'
Tooltip: 'Nash format (.nft)...'
"""

# ------------------------------------
# Informacia dlya polzovateley skripta
# ====================================

__author__ = ["Georgy Moshkin"]
__url__ = ("http://www.tmtlib.narod.ru")
__version__ = "2008.1.14"
__bpydoc__ = """\

Etot skript zapisivaet scenu v nash format. Prosto zapustite skript.

"""

# -----------------------
# Dobavlyaem nujnie uniti
# =======================

import Blender
from Blender.Mathutils import *
import struct, os, cStringIO, time, re
import math
from math import *

PI = 3.14159265
DEGTORAD = PI / 180.0
                     
# --------------------------
# Glavnaya procedura exporta
# ==========================

def my_export(filename):

	# -=((( Otrkoem file dlya zapisi )))=-

	myfile = open(filename, 'w')

	# -=((( Poluchim spisok obyektov tekushey sceni )))=-
        MYSCENE = Blender.Scene.GetCurrent()
	MYOBJECTS = MYSCENE.objects

	# -=((( Proydemsa po vsem objektam )))=-

	# export Meshey
	for object in MYOBJECTS:
		if object.getType() != 'Mesh': continue
		print 'mesh:' + object.name
		myfile.write("mesh %s \n\n" % object.name)
		mesh = object.getData()
                mesh.transform(object.matrix, True)
		faces = mesh.faces

		myfile.write("verts %i \n\n" %(len(mesh.verts)))
		for v in mesh.verts:
			myfile.write("vertxyz %f %f %f \n" % (v.co[0],v.co[1],v.co[2]))

			influences = mesh.getVertexInfluences(v.index)
			myfile.write("parents %i \n" % len(influences))

	                sum = 0.0
	                for bone_name, weight in influences:
				sum += weight

	                for bone_name, weight in influences:
	                  myfile.write("weight %s %f \n" % (bone_name.replace(' ','_'), weight/sum))
			
			myfile.write("\n")



		myfile.write("faces %i \n\n" %(len(mesh.faces)))

		for face in faces:
  			myfile.write("face %i \n" %len(face.v))

			if mesh.hasFaceUV():
				if face.image:
					myfile.write("texture %s \n" % Blender.sys.basename(face.image.getFilename()))
				else: myfile.write("texture NOTEXTURE\n")
                        else: myfile.write("texture NOTEXTURE\n")

			vertidx = 0
			while (vertidx<len(face.v)):
	  			myfile.write("id%i %i \n" % (vertidx+1,face.v[vertidx].index))
				vertidx = vertidx +1

			vertidx = 0
			while (vertidx<len(face.v)):
	  			myfile.write("nrm%i %f %f %f \n" % (vertidx+1,face.v[vertidx].no[0],face.v[vertidx].no[1],face.v[vertidx].no[2]))
				vertidx = vertidx +1


			vertidx = 0
			if mesh.hasFaceUV():
				while (vertidx<len(face.uv)):
					myfile.write("uv%i %f %f \n" % (vertidx+1,face.uv[vertidx][0],face.uv[vertidx][1]))
					vertidx = vertidx +1
				
			myfile.write("\n")

        # export Skeletov
	for object in MYOBJECTS:
		if object.getType() != 'Armature': continue
		print 'skelet:' + object.name
		myfile.write("armature %s\n" % object.name)

		skelet = object.getData()
                actions = Blender.Armature.NLA.GetActions()
		bones = skelet.bones.values()

		pose = object.getPose() 








		realnumbers = {}

		boneidx = 0
		zeroboneidx = 0
		for bone in bones:
			if (not bone.hasParent()) and (bone.hasChildren()):
				zeroboneidx = boneidx
				print 'FOUND ZERO! '+bone.name
			realnumbers[bone.name]=boneidx;
			boneidx = boneidx + 1

		print 'zero bone index %i' % zeroboneidx

		boneslist = []
		boneslist.append(bones[zeroboneidx])

		bonesparents = []
		bonesparents.append(-1)

		sortednames = []
		sortednames.append(bones[zeroboneidx].name)
		sortednumbers = {}
		sortednumbers[bones[zeroboneidx].name]=0

		ttt = 1
		while 1:
			newlist = []
			for bone in boneslist:
				if bone.hasChildren():
					for childbone in bone.children:
						sortednames.append(childbone.name)
						sortednumbers[childbone.name]=ttt
						bonesparents.append(sortednumbers[childbone.parent.name])
						newlist.append(childbone)
						ttt = ttt + 1

			boneslist = newlist
			
			if len(boneslist) == 0:
				break

		myfile.write('nodes %i\n' %len(sortednames))
		for bonename in sortednames:
			myfile.write('%i %s %i \n' %(sortednumbers[bonename],bonename.replace(' ','_'),bonesparents[sortednumbers[bonename]]))


		myfile.write('reference\n')


#		skelet.restPosition = True

		for bonename in sortednames:
			realBone = bones[realnumbers[bonename]]

			boneMat = realBone.matrix[ 'ARMATURESPACE' ] * object.matrix

			if realBone.hasParent():
				parentMat = realBone.parent.matrix[ 'ARMATURESPACE' ] * object.matrix 
				parentMat.invert()
				boneMat = boneMat * parentMat

			bone_pos = boneMat.translationPart()
			bone_rot = boneMat.toEuler()

			myfile.write ('%i %f %f %f %f %f %f yes\n' % ( sortednumbers[bonename],
								   bone_pos[0],
								   bone_pos[1],
								   bone_pos[2],
								   bone_rot[0] * DEGTORAD,
								   bone_rot[1] * DEGTORAD,
								   bone_rot[2] * DEGTORAD))

#		skelet.restPosition = False

		for action in actions.values():


			playtime = 0.0
			ipos = action.getAllChannelIpos()
			# determine playtime
			for bone in bones: #self.bones:
				if bone.name in ipos:
					boneIpo = ipos[bone.name]
					ipoCurve = boneIpo.getCurve( 'LocX' )
					if ipoCurve:
						for knot in ipoCurve.bezierPoints:
							if knot.pt[ 0 ] > playtime:
								playtime = knot.pt[ 0 ]
					ipoCurve = boneIpo.getCurve( 'LocY' )
					if ipoCurve:
						for knot in ipoCurve.bezierPoints:
							if knot.pt[ 0 ] > playtime:
								playtime = knot.pt[ 0 ]
					ipoCurve = boneIpo.getCurve( 'LocZ' )
					if ipoCurve:
						for knot in ipoCurve.bezierPoints:
							if knot.pt[ 0 ] > playtime:
								playtime = knot.pt[ 0 ]
					ipoCurve = boneIpo.getCurve( 'QuatX' )
					if ipoCurve:
						for knot in ipoCurve.bezierPoints:
							if knot.pt[ 0 ] > playtime:
								playtime = knot.pt[ 0 ]
					ipoCurve = boneIpo.getCurve( 'QuatY' )
					if ipoCurve:
						for knot in ipoCurve.bezierPoints:
							if knot.pt[ 0 ] > playtime:
								playtime = knot.pt[ 0 ]
					ipoCurve = boneIpo.getCurve( 'QuatZ' )
					if ipoCurve:
						for knot in ipoCurve.bezierPoints:
							if knot.pt[ 0 ] > playtime:
								playtime = knot.pt[ 0 ]
					ipoCurve = boneIpo.getCurve( 'QuatW' )
					if ipoCurve:
						for knot in ipoCurve.bezierPoints:
							if knot.pt[ 0 ] > playtime:
								playtime = knot.pt[ 0 ]
			playtime = int( round( playtime, 0 ) )
			if playtime < 1:
				playtime = 1
			print '- playtime', playtime



			actionname = action.getName()
			print 'skelet action:' + actionname

			action.setActive(object)

			scene = Blender.Scene.GetCurrent()
			context = scene.getRenderingContext()
			frames = range(context.startFrame(), context.endFrame()+1)
			fps = context.framesPerSec()
			print 'skelet action fps:%i' %fps

#			context.currentFrame(1)
#	 		scene.update(1)

			myfile.write('action %s\n' % actionname)
			myfile.write('fps %i \n' %fps)
#			myfile.write('frames %i \n' %(context.endFrame()-context.startFrame()+1+1))
			myfile.write('frames %i \n' %(playtime))
			myfile.write('\n')


#			for frame in frames:
			for time in range( 1, playtime + 1 ):

				myfile.write('\n')
#				myfile.write('frame %i\n' % frame)
				myfile.write('frame %i\n' % time)

#				context.currentFrame( frame )
#		 		scene.update( 1 )
				object.evaluatePose( time )


				for bonename in sortednames:
					realBone = bones[realnumbers[bonename]]

					boneMat = pose.bones[bonename].poseMatrix * object.matrix

					if realBone.hasParent():
						parentMat = pose.bones[realBone.parent.name].poseMatrix * object.matrix 
						parentMat.invert()
						boneMat = boneMat * parentMat

					bone_pos = boneMat.translationPart()
					bone_rot = boneMat.toEuler()

					ttt=''
					if bonename in ipos: ttt='yes' 
					else: ttt='no'
					myfile.write ('%i %f %f %f %f %f %f %s\n' % ( sortednumbers[bonename],
										   bone_pos[0],
										   bone_pos[1],
										   bone_pos[2],
										   bone_rot[0] * DEGTORAD,
										   bone_rot[1] * DEGTORAD,
										   bone_rot[2] * DEGTORAD,ttt))
##################################################


	# export Lamp
	for object in MYOBJECTS:
		if object.getType() != 'Lamp': continue
		print 'lamp:' + object.name

	# export Camer
	for object in MYOBJECTS:
		if object.getType() != 'Camera': continue
		print 'camera:' + object.name
			
	myfile.close() 


	# export  TEXTUR
	MYIMAGES = Blender.Image.Get()
	for myimage in MYIMAGES:
		if Blender.sys.basename(myimage.getFilename())!='':
			myimage.setFilename(Blender.sys.dirname(fname) + '/' + Blender.sys.basename(myimage.getFilename()))
		else: myimage.setFilename(Blender.sys.dirname(fname) + '/debug.png')
		if myimage.has_data: myimage.save()

# --------------------------------------------
# Vizivaem okno vibora imeni faila dlya zapisi
# ============================================

fname = Blender.sys.makename(ext=".nft")
Blender.Window.FileSelector(my_export, "Save NFT",fname)
