// -------------------------------------------------------------
// 3d code by Georgy Moshkin (Delphi)
// licence: public domain
// -------------------------------------------------------------
unit mygameobjects;

interface

uses myskeletons,
     mymodels,
     mytextures,
     myrender;

type TGameObject=record
                  modelIndex      : integer;
                  loadedFromIndex : integer;

                  skelState       : TSkeletonState;

                  collideWithObjects : array of integer;

                 end;

type TGameObjects = array of TGameObject;                 

var Models:TModels;
    Textures:TTextures;
    gameObjects:TGameObjects;

function loadGameObj(filename:string):integer;
procedure renderBones(index:integer);
procedure renderGameObj(index,animindex:integer;elapsed:single);
function getActionsCount(index:integer):integer;

implementation



function getActionsCount(index:integer):integer;
begin
result:=length(models[gameobjects[index].modelIndex].skAnimations.actions)
end;

function loadGameObj(filename:string):integer;
var k:integer;
begin
k:=length(gameObjects);
setlength(gameObjects,k+1);
gameObjects[k].modelIndex:=loadModel(filename,
                                     models,
                                     textures);
result:=k;
end;

procedure renderBones(index:integer);
begin
DrawBones(gameobjects[index].skelState.currentPose,
          models[gameobjects[index].modelIndex].skAnimations.skeleton);
end;          

procedure renderGameObj(index,animindex:integer;elapsed:single);
var i:integer;
begin


Anim(models[gameobjects[index].modelIndex].skAnimations.actions,
     gameobjects[index].skelState,
     animindex,
     elapsed);



BuildFrame(gameobjects[index].skelState.currentPose,
           models[gameobjects[index].modelIndex].skAnimations.skeleton);




for i:=0 to length(models[gameobjects[index].modelIndex].Meshes)-1 do
  Transform(models[gameobjects[index].modelIndex].Meshes[i].transVerts,
            models[gameobjects[index].modelIndex].Meshes[i].restVerts,
            models[gameobjects[index].modelIndex].Meshes[i].vertsParents,
            gameobjects[index].skelState.currentPose,
            models[gameobjects[index].modelIndex].skAnimations.reference,
            models[gameobjects[index].modelIndex].skAnimations.skeleton);


for i:=0 to length(models[gameobjects[index].modelIndex].Meshes)-1 do
      DrawPolys(models[gameobjects[index].modelIndex].Meshes[i].polygons,
                models[gameobjects[index].modelIndex].Meshes[i].transVerts);

end;




end.
